var version="1.0";
var version_re= /version=(.+?)$/;
var beta_v_re = /.*\a\d*$/;

var plateau;

var currentUser;

var userFolder;

var widgetDir;

var playername;

var isIphone=false;

isIphone=navigator.userAgent.indexOf("iPhone") != -1;
	

function newPlateau() {
	document.getElementById("winCongratulation").style.display="none";
	document.getElementById("winNbMoves").style.display="none";
	document.getElementById("winNbMovesValue").style.display="none";
	document.getElementById("winNewButton").style.display="none";
	document.getElementById("winReloadButton").style.display="none";
	return new Array(
			  new Array(  -2, -2, -2, -2, -2, -2, -2),
			  new Array(  -2, -1, -1, -1, -1, -1, -2),
			  new Array(  -2, -1, -1, -1, -1, -1, -2),
			  new Array(  -2, -1, -1, -1, -1, -1, -2),
			  new Array(  -2, -1, -1, -1, -1, -1, -2),
			  new Array(  -2, -2, -2, -2, -2, -2, -2));
}

/**
 *   Array convenience method to check for membership.
 *
 *   @param object element
 *   @returns boolean
 */
Array.prototype.contains = function (element) {
    for (var i = 0; i < this.length; i++) {
        if (this[i] == element) {
            return true;
        }
    }
    return false;
};

Array.prototype.insertAt = function (what, iIndex) {
	if (iIndex < this.length) {
		var aAfter = this.splice(iIndex, 100000, what);
		for (var i = 0; i < aAfter.length; i++) {
			this.push(aAfter[i]);
		}
	} else {
		this.push(what);
	}
}

Array.prototype.getIndex = function (element) {
	//alert("coucou");
    for (var i = 0; i < this.length; i++) {
        if (this[i] == element) {
            return i;
        }
    }
    return -1;
};

/**
 *   Array convenience method to clear membership.
 *
 *   @param object element
 *   @returns void
 */
Array.prototype.clear = function () {
    this.length = 0;
};

Array.prototype.copy = function(list) {
	this.clear();
	for (var i=0;i<list.length;i++) {
		this.push(list[i]);
	}
}
        
/**
 *   Array convenience method to remove element.
 *
 *   @param object element
 *   @returns boolean
 */
Array.prototype.remove = function (element) {
        var result = false;
        var array = [];
        for (var i = 0; i < this.length; i++) {
                if (this[i] == element) {
                        result = true;
                } else {
                        array.push(this[i]);
                }
        }
        this.clear();
        for (var i = 0; i < array.length; i++) {
                this.push(array[i]);
        }
        array = null;
        return result;
};


var currentGameId=-1;

var count=0;

var level=0;

var todoNumber=0;

var min=0;

var selectedPiece=-1;

var xo=37;
var yo=36;
var delta=63;

var lastMoved=-1;

var preferencesDisplayed=false;

function newCoord() {
	return {x:0,y:0};
}

function newCoordXY(valX, valY ) {
	return {x:valX,y:valY};
}

var virtualPieceCoord=newCoord();


var pieces = new Array();
				/*[newCoordXY(1,1), newCoordXY(1,2)], //yellow1
				[newCoordXY(2,1), newCoordXY(3,1),newCoordXY(2,2), newCoordXY(3,2)], //red
				[newCoordXY(4,1), newCoordXY(4,2)], //yellow2
				[newCoordXY(1,3), newCoordXY(1,4)], //black1
				[newCoordXY(2,3), newCoordXY(3,3)], //white
				[newCoordXY(4,3), newCoordXY(4,4)], //black2
				[newCoordXY(2,4)], //orange1
				[newCoordXY(3,4)], //orange2
				[newCoordXY(1,5)], //brown1
				[newCoordXY(4,5)]); //brown2
				*/
var configs = [ new Array(
				[newCoordXY(1,1), newCoordXY(1,2)], //yellow1
				[newCoordXY(2,1), newCoordXY(3,1),newCoordXY(2,2), newCoordXY(3,2)], //red
				[newCoordXY(4,1), newCoordXY(4,2)], //yellow2
				[newCoordXY(1,3), newCoordXY(1,4)], //black1
				[newCoordXY(2,3), newCoordXY(3,3)], //white
				[newCoordXY(4,3), newCoordXY(4,4)], //black2
				[newCoordXY(2,4)], //orange1
				[newCoordXY(3,4)], //orange2
				[newCoordXY(1,5)], //brown1
				[newCoordXY(4,5)]) , //brown2
				new Array(
				[newCoordXY(1,1), newCoordXY(1,2)], //yellow1
				[newCoordXY(2,1), newCoordXY(3,1),newCoordXY(2,2), newCoordXY(3,2)], //red
				[newCoordXY(4,1), newCoordXY(4,2)], //yellow2
				[newCoordXY(1,4), newCoordXY(1,5)], //black1
				[newCoordXY(2,4), newCoordXY(3,4)], //white
				[newCoordXY(4,4), newCoordXY(4,5)], //black2
				[newCoordXY(2,3)], //orange1
				[newCoordXY(3,3)], //orange2
				[newCoordXY(1,3)], //brown1
				[newCoordXY(4,3)]), //brown2
				new Array(
				[newCoordXY(1,1), newCoordXY(1,2)], //yellow1
				[newCoordXY(2,1), newCoordXY(3,1),newCoordXY(2,2), newCoordXY(3,2)], //red
				[newCoordXY(4,1), newCoordXY(4,2)], //yellow2
				[newCoordXY(2,3), newCoordXY(2,4)], //black1
				[newCoordXY(2,5), newCoordXY(3,5)], //white
				[newCoordXY(3,3), newCoordXY(3,4)], //black2
				[newCoordXY(1,4)], //orange1
				[newCoordXY(4,4)], //orange2
				[newCoordXY(1,3)], //brown1
				[newCoordXY(4,3)]), //brown2
				new Array(
				[newCoordXY(2,4), newCoordXY(2,5)], //yellow1
				[newCoordXY(2,1), newCoordXY(3,1),newCoordXY(2,2), newCoordXY(3,2)], //red
				[newCoordXY(3,4), newCoordXY(3,5)], //yellow2
				[newCoordXY(1,1), newCoordXY(1,2)], //black1
				[newCoordXY(2,3), newCoordXY(3,3)], //white
				[newCoordXY(4,1), newCoordXY(4,2)], //black2
				[newCoordXY(1,4)], //orange1
				[newCoordXY(4,4)], //orange2
				[newCoordXY(1,3)], //brown1
				[newCoordXY(4,3)]), //brown2
				new Array(
				[newCoordXY(1,1), newCoordXY(1,2)], //yellow1
				[newCoordXY(2,1), newCoordXY(3,1),newCoordXY(2,2), newCoordXY(3,2)], //red
				[newCoordXY(4,1), newCoordXY(4,2)], //yellow2
				[newCoordXY(1,4), newCoordXY(1,5)], //black1
				[newCoordXY(2,3), newCoordXY(3,3)], //white
				[newCoordXY(4,4), newCoordXY(4,5)], //black2
				[newCoordXY(2,4)], //orange1
				[newCoordXY(3,4)], //orange2
				[newCoordXY(1,3)], //brown1
				[newCoordXY(4,3)]), //brown2	
				new Array(
				[newCoordXY(1,1), newCoordXY(1,2)], //yellow1
				[newCoordXY(2,1), newCoordXY(3,1),newCoordXY(2,2), newCoordXY(3,2)], //red
				[newCoordXY(4,1), newCoordXY(4,2)], //yellow2
				[newCoordXY(1,3), newCoordXY(1,4)], //black1
				[newCoordXY(2,4), newCoordXY(3,4)], //white
				[newCoordXY(4,3), newCoordXY(4,4)], //black2
				[newCoordXY(1,5)], //orange1
				[newCoordXY(4,5)], //orange2
				[newCoordXY(2,3)], //brown1
				[newCoordXY(3,3)]), //brown2	
				new Array(
				[newCoordXY(1,2), newCoordXY(1,3)], //yellow1
				[newCoordXY(2,1), newCoordXY(3,1),newCoordXY(2,2), newCoordXY(3,2)], //red
				[newCoordXY(4,2), newCoordXY(4,3)], //yellow2
				[newCoordXY(1,4), newCoordXY(1,5)], //black1
				[newCoordXY(2,4), newCoordXY(3,4)], //white
				[newCoordXY(4,4), newCoordXY(4,5)], //black2
				[newCoordXY(2,3)], //orange1
				[newCoordXY(3,3)], //orange2
				[newCoordXY(1,1)], //brown1
				[newCoordXY(4,1)]), //brown2
				new Array(
				[newCoordXY(1,1), newCoordXY(2,1)], //yellow1
				[newCoordXY(2,2), newCoordXY(3,2),newCoordXY(2,3), newCoordXY(3,3)], //red
				[newCoordXY(3,1), newCoordXY(4,1)], //yellow2
				[newCoordXY(1,2), newCoordXY(1,3)], //black1
				[newCoordXY(2,4), newCoordXY(3,4)], //white
				[newCoordXY(4,2), newCoordXY(4,3)], //black2
				[newCoordXY(1,4)], //orange1
				[newCoordXY(4,4)], //orange2
				[newCoordXY(1,5)], //brown1
				[newCoordXY(4,5)]) //brown2		
			];
			 
				
var colors = new Array( "yellow", "red", "yellow", "black", "white", "black", "orange", "orange", "brown", "brown" );

var levels = ["Easy", "Medium", "Hard", "Very Hard"];

var todo = [
	[ 
		[
			{lvl: 0, scores:new Array(), min:12, cond: " && ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 noires
		],[
			{lvl: 1, scores:new Array(), min:25, cond: null, pieces: [ {id: 4, coords: [newCoordXY(2,5)]}]}, //blanche
			{lvl: 1, scores:new Array(), min:25, cond: " || ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //1 jaune
		],[
			{lvl: 2, scores:new Array(), min:25, cond: " && ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 jaunes
		],[
			{lvl: 3,scores:new Array(),  min:81, cond: null, pieces: [ {id: 1, coords: [newCoordXY(2,4)]}]} //rouge
		]
	],
	[ 
		[
			{lvl: 0, scores:new Array(), min:20, cond: " || ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]}  //1 jaune
		],[
			{lvl: 1, scores:new Array(), min:20, cond: " && ", pieces: [ {id: 6, coords: [newCoordXY(2,5), newCoordXY(3,5)]}, {id: 7, coords: [newCoordXY(2,5), newCoordXY(3,5)]}]}, //2 oranges
			{lvl: 1, scores:new Array(), min:22, cond: " && ", pieces: [ {id: 8, coords: [newCoordXY(2,5), newCoordXY(3,5)]}, {id: 9, coords: [newCoordXY(2,5), newCoordXY(3,5)]}]} //2 marrons
		],[
			{lvl: 2, scores:new Array(), min:25, cond: " && ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]}, //2 noires
			{lvl: 2, scores:new Array(), min:39, cond: " && ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 jaunes
		],[
			{lvl: 3, scores:new Array(), min:60, cond: null, pieces: [ {id: 1, coords: [newCoordXY(2,4)]}]} //rouge
		]
	],
	[ 
		[
			{lvl: 0, scores:new Array(), min:17, cond: " && ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 noires
		],[
			{lvl: 1, scores:new Array(), min:20, cond: " && ", pieces: [ {id: 8, coords: [newCoordXY(2,5), newCoordXY(3,5)]}, {id: 9, coords: [newCoordXY(2,5), newCoordXY(3,5)]}]}, //2 marrons
			{lvl: 1, scores:new Array(), min:21, cond: " && ", pieces: [ {id: 6, coords: [newCoordXY(2,5), newCoordXY(3,5)]}, {id: 7, coords: [newCoordXY(2,5), newCoordXY(3,5)]}]} //2 oranges
		],[
			{lvl: 2, scores:new Array(), min:29, cond: " && ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 jaunes
		],[
			{lvl: 3, scores:new Array(), min:60, cond: null, pieces: [ {id: 1, coords: [newCoordXY(2,4)]}]} //rouge
		]
	],
	[ 
		[
			{lvl: 0, scores:new Array(), min:13, cond: " && ", pieces: [ {id: 8, coords: [newCoordXY(2,5), newCoordXY(3,5)]}, {id: 9, coords: [newCoordXY(2,5), newCoordXY(3,5)]}]} //2 marrons
		],[
			{lvl: 1, scores:new Array(), min:20, cond: null, pieces: [ {id: 4, coords: [newCoordXY(2,5)]}]}, //blanche
			{lvl: 1, scores:new Array(), min:32, cond: " || ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //1 noire
		],[
			{lvl: 2, scores:new Array(), min:43, cond: " && ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 noires
		],[
			{lvl: 3, scores:new Array(), min:76, cond: null, pieces: [ {id: 1, coords: [newCoordXY(2,4)]}]} //rouge
		]
	],
	[ 
		[
			{lvl: 0, scores:new Array(), min:17, cond: " || ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]}  //1 jaune
		],[
			{lvl: 1, scores:new Array(), min:20, cond: " && ", pieces: [ {id: 8, coords: [newCoordXY(2,5), newCoordXY(3,5)]}, {id: 9, coords: [newCoordXY(2,5), newCoordXY(3,5)]}]} //2 marrons
		],[
			{lvl: 2, scores:new Array(), min:24, cond: " && ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]}, //2 noires
			{lvl: 2, scores:new Array(), min:28, cond: " && ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 jaunes
		],[
			{lvl: 3, scores:new Array(), min:70, cond: null, pieces: [ {id: 1, coords: [newCoordXY(2,4)]}]} //rouge
		]
	],
	[ 
		[
			{lvl: 0, scores:new Array(), min:15, cond: " || ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]}  //1 jaune
		],[
			{lvl: 1, scores:new Array(), min:27, cond: " && ", pieces: [ {id: 8, coords: [newCoordXY(2,5), newCoordXY(3,5)]}, {id: 9, coords: [newCoordXY(2,5), newCoordXY(3,5)]}]} //2 marrons
		],[
			{lvl: 2, scores:new Array(), min:31, cond: " && ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]}, //2 noires
			{lvl: 2, scores:new Array(), min:35, cond: " && ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 jaunes
		],[
			{lvl: 3, scores:new Array(), min:70, cond: null, pieces: [ {id: 1, coords: [newCoordXY(2,4)]}]} //rouge
		]
	],
	[
		[
			{lvl: 0, scores:new Array(), min:22, cond: " || ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //1 noire
		],[
			{lvl: 1, scores:new Array(), min:26, cond: " && ", pieces: [ {id: 6, coords: [newCoordXY(2,5), newCoordXY(3,5)]}, {id: 7, coords: [newCoordXY(2,5), newCoordXY(3,5)]}]}, //2 oranges
			{lvl: 1, scores:new Array(), min:32, cond: null, pieces: [ {id: 1, coords: [newCoordXY(2,4)]}]} //rouge
		],[
			{lvl: 2,scores:new Array(),  min:35, cond: " && ", pieces: [ {id: 8, coords: [newCoordXY(2,5), newCoordXY(3,5)]}, {id: 9, coords: [newCoordXY(2,5), newCoordXY(3,5)]}]} //2 marrons
		],[
			{lvl: 3, scores:new Array(), min:52, cond: " && ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]}, //2 noires
			{lvl: 3, scores:new Array(), min:54, cond: " && ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 jaunes
		]
	],
	[
		[
			{lvl: 0, scores:new Array(), min:31, cond: " && ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 noires
		],[
			{lvl: 1, scores:new Array(), min:31, cond: " && ", pieces: [ {id: 3, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 5, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]} //2 noires
		],[
			{lvl: 2, scores:new Array(), min:36, cond: null, pieces: [ {id: 1, coords: [newCoordXY(2,4)]}]}
		],[
			{lvl: 3, scores:new Array(), min:69, cond: " || ", pieces: [ {id: 0, coords: [newCoordXY(2,4), newCoordXY(3,4)]}, {id: 2, coords: [newCoordXY(2,4), newCoordXY(3,4)]}]}  //1 jaune
		]
	]
];

function getPieceObject(i) {
	return document.getElementById("piece"+i);
}			

function initPieceImage(i) {
	var ext="";
	if (i==0 || i==2 || i==3 || i==4 || i==5) {
			if (pieces[i][1].y-pieces[i][0].y==0)
				ext="_h";
			else
				ext="_v";
	} else {
			ext="";
	}
	getPieceObject(i).src="Images/"+colors[i]+ext+".png";
} 

function initGameFromTemplate(configNb) {
	pieces.length=0;
	//alert("configNb= "+configNb);
	pieces.length=configs[configNb].length;
	var newTab;
	for (var i=0;i<configs[configNb].length;i++) {
		var tab=configs[configNb][i];
		newTab=pieces[i];
		if (newTab==null) {
			newTab=new Array();
		}
		newTab.length=tab.length;
		for (var j=0;j<tab.length;j++) {
			newTab[j]=newCoordXY(tab[j].x,tab[j].y);
		}
		pieces[i]=newTab;
	}
}

function placePieces() {
	for (var i=0;i<pieces.length;i++) {
		initPieceImage(i);
		getPieceObject(i).style.left=(xo+((pieces[i][0].x - 1) * delta))+"px";
		getPieceObject(i).style.top=(yo+((pieces[i][0].y - 1) * delta))+"px";
		getPieceObject(i).style.display="inline";
		var coord;
		for (var j=0;j<pieces[i].length;j++) {
			coord=pieces[i][j];
			plateau[coord.x][coord.y]=i;
		}
		
	}
	CreateText('countValue', { text: count });
	testVictory();
}

function testVictory() {
	var win=true;
	var solution=todo[currentGameId][level][todoNumber];
	
	if (solution.cond && solution.cond==" && ") {
		win=false;
		var nbWin=0;
		
		for (var i=0;!win && i<solution.pieces.length;i++) {
			var testPiece=false;
			for (var j=0;!testPiece && j<solution.pieces[i].coords.length;j++) {
				testPiece=(
							pieces[solution.pieces[i].id][0].x==solution.pieces[i].coords[j].x
						&&  pieces[solution.pieces[i].id][0].y==solution.pieces[i].coords[j].y
						  );
			}
			if (testPiece) nbWin++;
		}
		if (nbWin==solution.pieces.length) {
			win=true;
		}
	} else {
		var testPiece=false;
		win=false;
		for (var i=0;!win && i<solution.pieces.length;i++) {
			for (var j=0;!win && j<solution.pieces[i].coords.length;j++) {
				win=(
							pieces[solution.pieces[i].id][0].x==solution.pieces[i].coords[j].x
						&&  pieces[solution.pieces[i].id][0].y==solution.pieces[i].coords[j].y
						  );
			}
		}
	}
	
	
	if (win) {
		getPieceObject(selectedPiece).style.borderStyle="none";
		selectedPiece=-1;
		for (var i=0;i<pieces.length;i++) {
			getPieceObject(i).style.display="none";
		}
		document.getElementById("virtualPiece").style.display="none";
		document.getElementById("winCongratulation").style.display="inline";
		document.getElementById("winNbMoves").style.display="inline";
		CreateText('winNbMovesValue', { text: count });
		document.getElementById("winNbMovesValue").style.display="inline";
		document.getElementById("winNewButton").style.display="inline";
		document.getElementById("winReloadButton").style.display="inline";
		if (window.widget) {
			var userScore=newScore();
			userScore.grid=currentGameId;
			userScore.lvl=level;
			userScore.config=todoNumber;
			userScore.name=playername;
			userScore.nbmoves=count;
			insertScore(userScore);
		
			saveScore();
			displayScore();
		}
	}
}

function rand(val) {
   now=new Date();
   num=(now.getSeconds())%val;
   return num;
}

function clicked(url) 
{ 
	if (window.widget) 
	{ 
		window.widget.openURL(url); 
	} else {
		window.open(url);
	}
}

function initGames() {
	document.getElementById("alertShape").style.display="none";
	CreateText('versionText', { text: "Version: "+version });
	CreateText('backTitle', { text: "Ane Rouge "+version });
	
	if (window.widget) {
		currentUser=widget.system("/usr/bin/whoami",null).outputString;
		currentUser=currentUser.substr(0, currentUser.length-1);
		userFolder=widget.system("/bin/echo ~",null).outputString;
		userFolder=userFolder.substr(0, userFolder.length-1);
		widgetDir=widget.system("/bin/pwd",null).outputString;
		checkUpdate();
		readScores();
	} else {
		currentUser="web";
	}
	
	
	
	plateau=newPlateau();
	if (window.widget) {
		if (widget.preferenceForKey(createkey("currentGameId"))) {
			currentGameId=widget.preferenceForKey(createkey("currentGameId"));
			count=widget.preferenceForKey(createkey("count"));
			level=widget.preferenceForKey(createkey("level"));
			todoNumber=widget.preferenceForKey(createkey("todoNumber"));
			var savedCurrentGame=widget.preferenceForKey(createkey("savedCurrentGame"));
			playername=widget.preferenceForKey(createkey("playername"));
			
			var savedPieces=savedCurrentGame.split("|");
			pieces.length=0;
			pieces.length=savedPieces.length;

			for (var i=0;i<savedPieces.length;i++) {
				var tab=savedPieces[i].split(";");
				pieces[i]=new Array();
				for (var j=0;j<tab.length;j++) {
					var coord=newCoord();
					var coord_re=/(\d+?)-(\d+?)/;
					
					if (coord_re.test(tab[j])) {
						coord_re.exec(tab[j]);
						coord.x=RegExp.$1;
						coord.y=RegExp.$2;
					}
					pieces[i].push(coord);
				}
			}
			widget.setPreferenceForKey(null,createkey("savedCurrentGame"));
			initGameFromTemplate(currentGameId);
			placePieces();
		} else {
			playername=currentUser;
			newGame();
		}
	} else {
		playername=currentUser;
		newGame();
	}
	
	if (window.widget) {
		document.getElementById("nameField").value=playername;
		setSelectedLevel();
	}
	CreateText('countValue', { text: count });
}

function updateNameField() {
	playername=document.getElementById("nameField").value;
}

function setNewLevel() {
	var todos=todo[currentGameId][level];
	//alert("Nb todo: "+todos.length);
	if (todos.length==1)
		todoNumber=0;
	else
		todoNumber=rand(todos.length-1);
	//alert("level "+currentGameId+" "+level+" "+todoNumber);
}

function newGame(event) {
	plateau=newPlateau();
	var oldGameId=currentGameId;
	while (currentGameId==oldGameId)
		currentGameId=rand(8);
	initGameFromTemplate(currentGameId);
	count=0;
	placePieces();
	setNewLevel() ;
	min = todo[currentGameId][level][todoNumber].min;
	CreateText('minValue', { text: min });
	document.getElementById("targetImg").src="Images/target_"+colors[todo[currentGameId][level][todoNumber].pieces[0].id]+".png";
	document.getElementById("targetImg").style.display="inline";
	var targetTodo=todo[currentGameId][level][todoNumber].pieces.length;
	if (targetTodo==2 && todo[currentGameId][level][todoNumber].cond==" || ") {
		targetTodo=1;
	}
	CreateText('targetCount', { text: targetTodo+"x" });
	document.getElementById("targetCount").style.display="inline";
	if (selectedPiece!=-1) getPieceObject(selectedPiece).style.borderStyle="none";
	selectedPiece=-1;
	document.getElementById("virtualPiece").style.display="none";
	if (preferencesDisplayed) closePreferences();
}

function restartGame(event) {
	plateau=newPlateau();
	initGameFromTemplate(currentGameId);
	count=0;
	if (selectedPiece!=-1) getPieceObject(selectedPiece).style.borderStyle="none";
	selectedPiece=-1;
	document.getElementById("virtualPiece").style.display="none";
	placePieces();
	if (preferencesDisplayed) closePreferences();
}


function changeLevel() {
	/*var object=document.getElementById("lvlPopup");
	var content="";
	for (var i=0;i<levels.length;i++) {
		content+="<option apple-group='popup' value='"+i+"'>"+getLocalizedString(levels[i])+"</option>\n";
	}
	object.innerHTML=content;*/
	level=(level+1)%levels.length;
	setSelectedLevel();
}

function setSelectedLevel() {
	document.getElementById("levelbutton").src="Images/"+levels[level]+".png";
}


function getLevel() {
	//level=document.getElementById("lvlPopup").value;
	newGame();
}


function closePreferences(event) {		
	showFront(event);
	preferencesDisplayed=false;
}

function showPreferences(event) {
	preferencesDisplayed=true;
	showBack(event);
}

function canMovePiece(id, deltaX, deltaY) {
	var result=true;
	var casePlateau;
	//if ((deltaX==0 && deltaY==0)||(deltaX!=0 && deltaY!=0)) return false;
	
	
	
	//alert("CanMove "+deltaX+" "+deltaY);
	
	
	
	for (var i=0;result && i<pieces[id].length;i++) {
		
		//alert("selectedPiece: "+selectedPiece+"("+pieces[id][i].x+", "+pieces[id][i].y+")");
		var tabx=pieces[id][i].x+deltaX;
		var taby=pieces[id][i].y+deltaY;
		
		if (!(tabx>=1 && tabx<=4 && taby>=1 && taby<=5)) {
			//alert("en dehors du plateau");
			result=false;
		}
		
		//alert(deltaX);
		//alert(deltaY);
		
		var incrX=0;
		var incrY=0;
		
		if (deltaX!=0) incrX=deltaX/Math.abs(deltaX);
		if (deltaY!=0) incrY=deltaY/Math.abs(deltaY);
		
		
		//alert("0 ; < "+Math.abs(deltaX)+" ; "+(incrX));
		//alert("0 ; < "+Math.abs(deltaY)+" ; "+(incrY));
		if (result) {
			result=true;
			
			
			//alert(incrX+" < "+ (Math.abs(deltaX)+1)+" "+incrX);
			
			
			for (var x=incrX;result && Math.abs(x)<Math.abs(deltaX+incrX);x+=incrX) {
				casePlateau=plateau[pieces[id][i].x+x][pieces[id][i].y];
				result=(casePlateau==-1 || casePlateau==selectedPiece);
			}
			
			
			if (result) { 
				//alert("passe horizontalement");
				for (var y=incrY;result && Math.abs(y)<Math.abs(deltaY+incrY);y+=incrY) {
					casePlateau=plateau[pieces[id][i].x+deltaX][pieces[id][i].y+y];
					result=(casePlateau==-1 || casePlateau==selectedPiece);
				}
			} else {
				//alert("passe pas horizontalement");
				result=true;
				for (var y=incrY;result && Math.abs(y)<Math.abs(deltaY+incrY);y+=incrY) {
					casePlateau=plateau[pieces[id][i].x][pieces[id][i].y+y];
					result=(casePlateau==-1 || casePlateau==selectedPiece);
				}
				if (result) { //obstacle en Y
					//alert("passe verticalement");
					for (var x=incrX;result && Math.abs(x)<Math.abs(deltaX+incrX);x+=incrX) {
						casePlateau=plateau[pieces[id][i].x+x][pieces[id][i].y+deltaY];
						result=(casePlateau==-1 || casePlateau==selectedPiece);
					}
				} else {
					//alert("ni verticalement");
				}
			}
			
			if (result) {
				casePlateau=plateau[pieces[id][i].x+deltaX][pieces[id][i].y+deltaY];
				result=(casePlateau==-1 || casePlateau==selectedPiece);
			}
			
		}
		
	}
	//alert("End CanMove "+result);
	
	return result;
}

function movePiece(id, deltaX, deltaY) {
	var oldCoords=new Array();
	oldCoords.length=pieces[id].length;
	
	for (var i=0;i<pieces[id].length;i++) {
		
		oldCoords[i]={x:pieces[id][i].x,y:pieces[id][i].y};
		//alert("old: "+oldCoords[i].x+" "+oldCoords[i].y);
	}
	
	for (var i=0;i<pieces[id].length;i++) {
		pieces[id][i].x+=deltaX;
		pieces[id][i].y+=deltaY;
		//alert("new: "+pieces[id][i].x+" "+pieces[id][i].y);
	}

	for (var i=0;i<pieces[id].length;i++) {
		//alert("old: "+oldCoords[i].x+" "+oldCoords[i].y);
		//alert("new: "+pieces[id][i].x+" "+pieces[id][i].y);
		plateau[oldCoords[i].x][oldCoords[i].y]=-1;
		plateau[pieces[id][i].x][pieces[id][i].y]=id;
	}
	
	if (lastMoved!=id) {
		count++;
		lastMoved=id;
	}
	placePieces();
	//alert(plateau);
}


function selectPiece(event, id) {
	var oldSelected;
	var newSelected;
	var virtualPiece=document.getElementById("virtualPiece");
	//if (virtualPieceCoord.x==0 && virtualPieceCoord.y==0) {
		if (selectedPiece!=-1) {
			oldSelected=getPieceObject(selectedPiece);
			oldSelected.style.borderStyle="none";
			virtualPiece.style.display="none";
			oldSelected.style.top=(parseInt(oldSelected.style.top.substring(0,oldSelected.style.top.length-2))+1)+"px";
			oldSelected.style.left=(parseInt(oldSelected.style.left.substring(0,oldSelected.style.left.length-2))+1)+"px";
			oldSelected.style.zIndex=1;
		}
		if (selectedPiece!=id) {
			newSelected=getPieceObject(id);
			newSelected.style.borderStyle="inset";
			newSelected.style.borderColor="rgb(5, 255, 50)";
			newSelected.style.borderWidth="2px";
			newSelected.style.top=(parseInt(newSelected.style.top.substring(0,newSelected.style.top.length-2)) - 1)+"px";
			newSelected.style.left=(parseInt(newSelected.style.left.substring(0,newSelected.style.left.length-2)) - 1)+"px";
			newSelected.style.zIndex=10;
			selectedPiece=id;
		} else {
			selectedPiece=-1;
		}
	/*} else {
		if (selectedPiece!=-1) {
			movePiece(selectedPiece, virtualPieceCoord.x, virtualPieceCoord.y);
		}
	}*/
}

function clickOnEmptySpace() {
	if (virtualPieceCoord.x==0 && virtualPieceCoord.y==0) {
	
	} else {
		if (selectedPiece!=-1) {
			movePiece(selectedPiece, virtualPieceCoord.x, virtualPieceCoord.y);
		}
	}
}

function getDelta(id, x, y) {
	var piece=pieces[id];
	var deltaP={x:100,y:100};
	var distance=1000;
	var val;
	for (var i=0;i<piece.length;i++) {
		val=(Math.pow(x-piece[i].x,2)+Math.pow(y-piece[i].y,2));
		if (distance>val) {
			distance=val;
			deltaP.x=x-piece[i].x;
			deltaP.y=y-piece[i].y;
		}
	}
	return deltaP;
}

function displayVirtualPiece(event) {
	var virtualPiece=document.getElementById("virtualPiece");

	virtualPieceCoord.x=0;
	virtualPieceCoord.y=0;

	if (selectedPiece!=-1) {
		var newSelected=getPieceObject(selectedPiece);
		
		if (event.x) {
			var tabx=Math.floor((event.x-xo)/delta) + 1;
			var taby=Math.floor((event.y-yo)/delta) + 1;
		} else {
			var tabx=Math.floor((event.pageX-xo)/delta) + 1;
			var taby=Math.floor((event.pageY-yo)/delta) + 1;		
		}
		
		
		if (tabx>=1 && tabx<=4 && taby>=1 && taby<=5 && (plateau[tabx][taby]==-1 || plateau[tabx][taby]==selectedPiece)) {
			
			var deltaX=pieces[selectedPiece][0].x-tabx;
			var deltaY=pieces[selectedPiece][0].y-taby;
			
			var deltaP=getDelta(selectedPiece, tabx, taby);
			
			if (canMovePiece(selectedPiece, deltaP.x, deltaP.y)) {
				
				virtualPieceCoord.x=deltaP.x;
				virtualPieceCoord.y=deltaP.y;
				
				virtualPiece.style.left=(xo+(((pieces[selectedPiece][0].x+deltaP.x)-1) * delta))+"px";
				virtualPiece.style.top=(yo+(((pieces[selectedPiece][0].y+deltaP.y)-1) * delta))+"px";
				
				virtualPiece.style.borderStyle="dotted";
				virtualPiece.style.borderColor="rgb(230, 21, 170)";
				virtualPiece.style.borderWidth="1px";
				virtualPiece.style.display="inline";
				
				var defView;
				
				if (document.defaultView) {
					defView=document.defaultView.getComputedStyle(newSelected, "");
				} else {
					//defView=newSelected.currentStyle;
					defView=newSelected;
				} 
				
				if (defView) {
					virtualPiece.style.height=defView.height;
					virtualPiece.style.width=defView.width;
				}
				
				virtualPiece.style.backgroundColor="rgb(31, 231, 4)";
				virtualPiece.style.opacity="0.65";
				newSelected.style.zIndex=11;
				if (isIphone) clickOnEmptySpace(event);
			} else {
				virtualPiece.style.borderStyle="none";
				virtualPiece.style.display="none";
			}
		} else {
			virtualPiece.style.borderStyle="none";
			virtualPiece.style.display="none";
		}
		
	} else {
		virtualPiece.style.borderStyle="none";
		virtualPiece.style.display="none";
	}
}

function openNewVersion() {
	clicked("http://ismileys.free.fr/download");
	closeAlertPanel();
}

function closeAlertPanel() {
	document.getElementById("newVersionText").style.display="none";
	document.getElementById("infoButton").style.display="none";
	document.getElementById("laterButton").style.display="none";
	document.getElementById("alertShape").style.display="none";
	document.getElementById("alertShape").style.display="none";
}

function saveScore() {
	var commande="/bin/echo \"";
	for (var i=0;i<todo.length;i++) {
		for (var j=0;todo[i] && j<todo[i].length;i++) {
			for (var k=0;todo[i][j] && k<todo[i][j].length;k++) {
				for (var l=0;l<todo[i][j][k].scores.length;l++) {
					commande+=i+"-"+j+"-"+k+":"+todo[i][j][k].scores[l].name+":"+todo[i][j][k].scores[l].nbmoves+"\n";
				}
			}
		}
	}
	commande+="\">"+userFolder+"/Library/\"Application Support\"/\"Ane rouge\"/scores.txt";
	widget.system(commande,null);
}

function newScore() {
	return {grid:0, lvl:0, config: 0, name: "", nbmoves:0};
}

function insertScore(myScore) {
	var listeScore=todo[myScore.grid][myScore.lvl][myScore.config].scores;
	var indice=-1;
	var toInsert=true;
	var tmpScore;
	
	for (var i=0;indice==-1 && i<listeScore.length;i++) {
		tmpScore=listeScore[i];
		if (tmpScore.nbmoves>myScore.nbmoves) indice=i;
	}
	if (indice==-1) {
		indice=listeScore.length;
	}
	

	if (indice>=1 && listeScore[indice-1].nbmoves==myScore.nbmoves && listeScore[indice-1].name==myScore.name)
		 toInsert=false;
	if (indice>10)
		toInsert=false;
		
	if (toInsert) {
		//alert("add "+indice+": "+myScore.name+" "+myScore.nbmoves);
		listeScore.insertAt(myScore, indice);
	}
}


function readScores() {
	var scoreFile=userFolder+"/Library/\"Application Support\"/\"Ane rouge\"/scores.txt";
	var cmd=widget.system("/usr/bin/more "+scoreFile,null);
	var out=cmd.outputString;
	var content="";
	if (out) {
		var scoresTab=out.split("\n");
		var score;
		for (var i=0;i<scoresTab.length;i++) {
			var score_re=/(\d+?)-(\d+?)-(\d+?):(.+):(\d+?)$/;
			if (score_re.test(scoresTab[i])) {
				score_re.exec(scoresTab[i]);
				score=newScore();
				score.grid=RegExp.$1;
				score.lvl=RegExp.$2;
				score.config=RegExp.$3;
				score.name=RegExp.$4;
				score.nbmoves=RegExp.$5;
				insertScore(score);
			}
		}
	}
	displayScore();
}

function displayScore() {
	var entete="";
	var content="";
	for (var i=0;i<todo.length;i++) {
		entete="<ul>Game "+i+" :";
		for (var j=0;todo[i] && j<todo[i].length;j++) {
			entete+="<ul>Level "+j+" : ";
			for (var k=0;todo[i][j] && k<todo[i][j].length;k++) {
				entete+="<ul>Config "+k+" ("+todo[i][j][k].min+") :";
				for (var l=0;l<todo[i][j][k].scores.length;l++) {
					content+=entete+"<li>"+todo[i][j][k].scores[l].name+" : "+todo[i][j][k].scores[l].nbmoves+"</li>";
					entete="";	
				}
				content+="</ul>";
			}
			content+="</ul>";
		}
		content+="</ul>";
	}
	document.getElementById("scrollArea").object.content.innerHTML=content;
}

function readDOM(filename, cached) { 
	var result;
    request = new XMLHttpRequest(); 
    var sep = (-1 < filename.indexOf("?")) ? "&" : "?"
    var url=filename;
    
    var result =null;
    try {
    	request.open("GET", url ,false); 
    	if (!cached) request.setRequestHeader("Cache-Control", "no-cache"); 
		request.overrideMimeType("text/xml");	
    	request.send(null); 
    	result = request.responseText; 
    } catch (er) {
    	result=null;
    }
    if (result) return result ;
    else return null ;
}

function checkUpdate() {
	page = readDOM("http://ismileys.free.fr/anerouge/version.txt", false);
	if (page!=null) {
		lines=page.split("\n");
		for( var i = 0; i < lines.length; i=i+1){
			line=lines[i];
			if (version_re.test(line)) {
				version_re.exec(line);
				online_version=RegExp.$1;
				test_version1=version;
				
				if (! beta_v_re.test(version)) {
					test_version1+="z";
				}
				
				test_version2=online_version;
				if (! beta_v_re.test(online_version)) {
					test_version2+="z";
				}
				
				if (test_version1<test_version2) {
					document.getElementById("alertShape").style.display="block";
					document.getElementById("newVersionText").style.display="block";
					document.getElementById("infoButton").style.display="block";
					document.getElementById("laterButton").style.display="block";
				} 
			}
		}
	} 
	
}


function openNewVersion() {
	clicked("http://ismileys.free.fr/download");
	closeAlertPanel();
}

function closeAlertPanel() {
	document.getElementById("newVersionText").style.display="none";
	document.getElementById("infoButton").style.display="none";
	document.getElementById("laterButton").style.display="none";
	document.getElementById("alertShape").style.display="none";
}